/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Download Scan.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

window.addEventListener("load", downscaninit, true);
window.addEventListener('close', downscanclose, true);
var dscan_strings;

function downscaninit() {

  	window.removeEventListener("load", downscaninit, true);

	var dscan_observerService = Components.classes["@mozilla.org/observer-service;1"]
	                                  .getService(Components.interfaces.nsIObserverService);
	//db_observerService.addObserver(db_dlObserver, "dl-progress", false);
	dscan_observerService.addObserver(dscan_dlObserver, "dl-done", false);
	//db_observerService.addObserver(db_dlObserver, "dl-cancel", false);
	//db_observerService.addObserver(db_dlObserver, "dl-failed", false);
	//db_observerService.addObserver(db_dlObserver, "dl-start", false);

	// Load localized strings
	dscan_strings = document.getElementById("downscanbundle");

	//toJavaScriptConsole();

}

function downscanclose() {
	
	var dscan_observerService = Components.classes["@mozilla.org/observer-service;1"]
	                                  .getService(Components.interfaces.nsIObserverService);
	//db_observerService.removeObserver(db_dlObserver, "dl-progress");
	dscan_observerService.removeObserver(dscan_dlObserver, "dl-done");
	//db_observerService.removeObserver(db_dlObserver, "dl-cancel");
	//db_observerService.removeObserver(db_dlObserver, "dl-failed");
	//db_observerService.removeObserver(db_dlObserver, "dl-start");
}

const dscan_dlObserver = {
  observe: function(subject, topic, state) {

  	//d(topic);

	if (topic == "dl-done") {

		var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		try {
			var shouldScan = pref.getBoolPref("downscan.function.virusScan");
			var excludeRaw = pref.getCharPref("downscan.function.virusExclude");
		}
		catch (e) {}

		if (shouldScan){
			
			var db_dl = subject.QueryInterface(Components.interfaces.nsIDownload);
			try{
				var elmpath = db_dl.targetFile.path;  // New firefox 0.9
			} catch (e){
				var elmpath = db_dl.target.path;      // Old firefox 0.8
			}

			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			if(wm.getMostRecentWindow("navigator:browser") != window) {  // Only want this executed once, so only do it with the most recent browser window
				return;
			}
			
			var dscan_excludeList = new Array ( );
			excludeRaw = excludeRaw.toLowerCase().replace(/\s/g,'');  // remove all whitespace
			dscan_excludeList = excludeRaw.split(",");
			var db_fileext = elmpath.split(".").pop().toLowerCase();
			for (var i=0; i<=dscan_excludeList.length; ++i) {
				if (db_fileext == dscan_excludeList[i])
					return;
			}

			try {
				var AVProgLoc = pref.getCharPref("downscan.function.virusLoc");
				var AVArgs = pref.getCharPref("downscan.function.virusArgs");
				var AVExecFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);

				// Arguments must be separated into an array
				var args = AVArgs.split(" ");
				for (var i=0; i<args.length; ++i){
					//d("->" + args[i] + "<-");
					if(args[i] == "[Path]")
						args[i] = elmpath;
				}

				AVExecFile.initWithPath(AVProgLoc);
				if (AVExecFile.exists()) {
					process.init(AVExecFile);
					process.run(false, args, args.length);
				}
				else {
					var db_notFound = dscan_strings.getString("AVnotFound");
					alert(db_notFound + AVProgLoc);
				}
			} catch (e) {
				var db_failedAV = dscan_strings.getString("failedAV");
				alert(db_failedAV);
				return;
			}

		}

    }
  }
}

/*
// Dump a message to Javascript Console
function d(msg){
	var acs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	acs.logStringMessage(msg);
}*/